/* IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-U18, 5737-M66
 *
 * (C) COPYRIGHT IBM CORP. 2011,2021
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

define([
	"dojo/main",
	"dojo/_base/declare",
	"ibm/tivoli/fwm/mxmap/_Base"
], function(dojo, declare, _Base) {
	/**
	 * This class creates a new Router implementation based on the current map provider.
	 */
	return declare([_Base], {
		provider:null,
		router:null,
		map:null,
		constructor:function(params){
			dojo.mixin(this,params);
		},
		createRouter:function(params){
			var deferred = new dojo.Deferred();

			require(["ibm/tivoli/fwm/mxmap/routing/impl/"+this.provider], dojo.hitch(function(MapProvider) {
				
				//trying to keep one instance of bing maps and google maps only;
				if(this.router!=null)
				{
					deferred.resolve(this.router);
				} else {
					var me = this;
					require(["dojo/ready"], dojo.hitch(function(ready) {
						ready(function() {
							me._params=params;
							me._routerInstance = new MapProvider(me._params);
							me.router = me._routerInstance;
							me._routerInstance.init();
							deferred.resolve(me._routerInstance);
						});
					}));
				}
			}));
			return deferred.promise;
		}
	});
});
