/* IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-U18, 5737-M66
 *
 * (C) COPYRIGHT IBM CORP. 2012,2021
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
define([
	"dojo/_base/declare",
	"ibm/tivoli/fwm/mxmap/toolbar/ext/QueryWeatherAlerts"
	], 
	function(declare, QueryWeatherAlerts) {
		/**
		 * Query nearby resources tool (with one more menu option)
		 */
		return declare([QueryWeatherAlerts], {
			// This version of _sendEventToLayer tries to append routeInfo to the resource record
			// so that the route color can be obtained and the icon color can match the route color
			_sendEventToLayer: function(layerName, layerData, avoidLayerEnabled)
			{
				var disp = this.map.getDispatcher();
				if(disp)
				{
					for (var i in layerData)
					{
						// Convert location accuracy from kilometers to meters.
						layerData[i].lbsdata.location_accuracy = layerData[i].lbsdata.location_accuracy * 1000;
					}

				}
				dojo.publish("addRecordsToLayer_" + this.map.getId(), [ layerName, layerData, true, null, null, avoidLayerEnabled ]);
			}
		});
})
