/* IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-U18, 5737-M66
 *
 * (C) COPYRIGHT IBM CORP. 2011,2021
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
define([
	"dojo/_base/declare",
	"ibm/tivoli/fwm/mxmap/toolbar/ext/_ToolTemplate",
	"ibm/tivoli/fwm/mxmap/_Base",
	"dijit/form/Button"
	], 
	function(declare, _ToolTemplate, _Base, Button) {
		/**
		 * Full Screen tool bar action.
		 */
		return declare([_ToolTemplate], {
			label: "Refresh",
			iconClass: "basicMapToolbarBtn refreshMapToolbarBtn",
			map: null,
			constructor: function(params)
			{
				dojo.mixin(this, params);

				var _label = ibm.tivoli.fwm.i18n.getMaxMsg("map", "refreshtoolbar");
				this.label = _label || this.label;
			},
			execute: function()
			{
				var refreshOptions = {
						zoom: true,
						disableMsgs: false,
						automatic: false
					};
				this.map.refreshMap(refreshOptions);
			},
			disable: function()
			{
				// does nothing
			},
			destroy: function()
			{
				this.destroyRecursive();
			}
		});
});
